/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

define(["dojo/_base/kernel","dojo/_base/declare","dojo/_base/lang","dojo/_base/html","dojo/_base/event","dojo/_base/connect","dijit","dijit/_Widget","dojox/gfx","dojo/fx/easing","./Range"],function(_1,_2,_3,_4,_5,_6,_7,_8,_9,_a,_b){
_1.experimental("dojox.gauges._Gauge");
return _1.declare("dojox.gauges._Gauge",[_8],{width:0,height:0,background:null,image:null,useRangeStyles:0,useTooltip:true,majorTicks:null,minorTicks:null,_defaultIndicator:null,defaultColors:[[0,84,170,1],[68,119,187,1],[102,153,204,1],[153,187,238,1],[153,204,255,1],[204,238,255,1],[221,238,255,1]],min:null,max:null,surface:null,hideValues:false,gaugeContent:undefined,_backgroundDefault:{color:"#E0E0E0"},_rangeData:null,_indicatorData:null,_drag:null,_img:null,_overOverlay:false,_lastHover:"",isContainer:true,startup:function(){
if(this.image===null){
this.image={};
}
this.connect(this.gaugeContent,"onmousedown",this.handleMouseDown);
this.connect(this.gaugeContent,"onmousemove",this.handleMouseMove);
this.connect(this.gaugeContent,"onmouseover",this.handleMouseOver);
this.connect(this.gaugeContent,"onmouseout",this.handleMouseOut);
this.connect(this.gaugeContent,"touchstart",this.handleTouchStart);
this.connect(this.gaugeContent,"touchend",this.handleTouchEnd);
this.connect(this.gaugeContent,"touchmove",this.handleTouchMove);
if(!_1.isArray(this.ranges)){
this.ranges=[];
}
if(!_1.isArray(this.indicators)){
this.indicators=[];
}
var _c=[],_d=[];
var i;
if(this.hasChildren()){
var _e=this.getChildren();
for(i=0;i<_e.length;i++){
if(/.*Indicator/.test(_e[i].declaredClass)){
_d.push(_e[i]);
continue;
}
switch(_e[i].declaredClass){
case _b.prototype.declaredClass:
_c.push(_e[i]);
break;
}
}
this.ranges=this.ranges.concat(_c);
this.indicators=this.indicators.concat(_d);
}
if(!this.background){
this.background=this._backgroundDefault;
}
this.background=this.background.color||this.background;
if(!this.surface){
this.createSurface();
}
this.addRanges(this.ranges);
if(this.minorTicks&&this.minorTicks.interval){
this.setMinorTicks(this.minorTicks);
}
if(this.majorTicks&&this.majorTicks.interval){
this.setMajorTicks(this.majorTicks);
}
for(i=0;i<this.indicators.length;i++){
this.addIndicator(this.indicators[i]);
}
this.inherited(arguments);
},hasChildren:function(){
return this.getChildren().length>0;
},buildRendering:function(){
var n=this.domNode=this.srcNodeRef?this.srcNodeRef:_1.create("div");
this.gaugeContent=_1.create("div",{className:"dojoxGaugeContent"});
this.containerNode=_1.create("div");
this.mouseNode=_1.create("div");
while(n.hasChildNodes()){
this.containerNode.appendChild(n.firstChild);
}
_1.place(this.gaugeContent,n);
_1.place(this.containerNode,n);
_1.place(this.mouseNode,n);
},_setTicks:function(_f,_10,_11){
var i;
if(_f&&_1.isArray(_f._ticks)){
for(i=0;i<_f._ticks.length;i++){
this._removeScaleTick(_f._ticks[i]);
}
}
var t={length:_10.length,offset:_10.offset,noChange:true};
if(_10.color){
t.color=_10.color;
}
if(_10.font){
t.font=_10.font;
}
if(_10.labelPlacement){
t.direction=_10.labelPlacement;
}
_10._ticks=[];
for(i=this.min;i<=this.max;i+=_10.interval){
if(i==this.max&&this._isScaleCircular()){
continue;
}
t.value=i;
if(_11){
if(_1.number){
t.label=(_10.fixedPrecision&&_10.precision)?_1.number.format(i,{places:_10.precision}):_1.number.format(i);
}else{
t.label=(_10.fixedPrecision&&_10.precision)?i.toFixed(_10.precision):i.toString();
}
}
_10._ticks.push(this._addScaleTick(t,_11));
}
return _10;
},_isScaleCircular:function(){
return false;
},setMinorTicks:function(_12){
this.minorTicks=this._setTicks(this.minorTicks,_12,false);
},setMajorTicks:function(_13){
this.majorTicks=this._setTicks(this.majorTicks,_13,true);
},postCreate:function(){
if(this.hideValues){
_1.style(this.containerNode,"display","none");
}
_1.style(this.mouseNode,"width","0");
_1.style(this.mouseNode,"height","0");
_1.style(this.mouseNode,"position","absolute");
_1.style(this.mouseNode,"z-index","100");
if(_7.Tooltip&&this.useTooltip){
_7.showTooltip("test",this.mouseNode,!this.isLeftToRight());
_7.hideTooltip(this.mouseNode);
}
},createSurface:function(){
this.gaugeContent.style.width=this.width+"px";
this.gaugeContent.style.height=this.height+"px";
this.surface=_9.createSurface(this.gaugeContent,this.width,this.height);
this._backgroundGroup=this.surface.createGroup();
this._rangeGroup=this.surface.createGroup();
this._minorTicksGroup=this.surface.createGroup();
this._majorTicksGroup=this.surface.createGroup();
this._overlayGroup=this.surface.createGroup();
this._indicatorsGroup=this.surface.createGroup();
this._foregroundGroup=this.surface.createGroup();
this._background=this._backgroundGroup.createRect({x:0,y:0,width:this.width,height:this.height});
this._background.setFill(this.background);
if(this.image.url){
var _14=this._backgroundGroup;
if(this.image.overlay){
_14=this._overlayGroup;
}
this._img=_14.createImage({width:this.image.width||this.width,height:this.image.height||this.height,src:this.image.url});
if(this.image.x||this.image.y){
this._img.setTransform({dx:this.image.x||0,dy:this.image.y||0});
}
}
},draw:function(){
var i;
if(!this.surface){
return;
}
this.drawBackground(this._backgroundGroup);
if(this._rangeData){
for(i=0;i<this._rangeData.length;i++){
this.drawRange(this._rangeGroup,this._rangeData[i]);
}
}
if(this._minorTicksData){
for(i=0;i<this._minorTicksData.length;i++){
this._minorTicksData[i].draw(this._minorTicksGroup);
}
}
if(this._majorTicksData){
for(i=0;i<this._majorTicksData.length;i++){
this._majorTicksData[i].draw(this._majorTicksGroup);
}
}
if(this._indicatorData){
for(i=0;i<this._indicatorData.length;i++){
this._indicatorData[i].draw(this._indicatorsGroup);
}
}
this.drawForeground(this._foregroundGroup);
},drawBackground:function(_15){
},drawForeground:function(_16){
},setBackground:function(_17){
if(!_17){
_17=this._backgroundDefault;
}
this.background=_17.color||_17;
this._background.setFill(this.background);
},addRange:function(_18){
this.addRanges([_18]);
},addRanges:function(_19){
if(!this._rangeData){
this._rangeData=[];
}
var _1a;
for(var i=0;i<_19.length;i++){
_1a=_19[i];
if((this.min===null)||(_1a.low<this.min)){
this.min=_1a.low;
}
if((this.max===null)||(_1a.high>this.max)){
this.max=_1a.high;
}
if(!_1a.color){
var _1b=this._rangeData.length%this.defaultColors.length;
if(_9.svg&&this.useRangeStyles>0){
_1b=(this._rangeData.length%this.useRangeStyles)+1;
_1a.color={style:"dojoxGaugeRange"+_1b};
}else{
_1b=this._rangeData.length%this.defaultColors.length;
_1a.color=this.defaultColors[_1b];
}
}
this._rangeData[this._rangeData.length]=_1a;
}
this.draw();
},_addScaleTick:function(_1c,_1d){
if(!_1c.declaredClass){
_1c=new this._defaultIndicator(_1c);
}
_1c._gauge=this;
if(_1d){
if(!this._majorTicksData){
this._majorTicksData=[];
}
this._majorTicksData[this._majorTicksData.length]=_1c;
_1c.draw(this._majorTicksGroup);
}else{
if(!this._minorTicksData){
this._minorTicksData=[];
}
this._minorTicksData[this._minorTicksData.length]=_1c;
_1c.draw(this._minorTicksGroup);
}
return _1c;
},_removeScaleTick:function(_1e){
var i;
if(this._majorTicksData){
for(i=0;i<this._majorTicksData.length;i++){
if(this._majorTicksData[i]===_1e){
this._majorTicksData.splice(i,1);
_1e.remove();
return;
}
}
}
if(this._minorTicksData){
for(i=0;i<this._minorTicksData.length;i++){
if(this._minorTicksData[i]===_1e){
this._minorTicksData.splice(i,1);
_1e.remove();
return;
}
}
}
},addIndicator:function(_1f){
if(!_1f.declaredClass){
_1f=new this._defaultIndicator(_1f);
}
_1f._gauge=this;
if(!_1f.hideValue){
this.containerNode.appendChild(_1f.domNode);
}
if(!this._indicatorData){
this._indicatorData=[];
}
this._indicatorData[this._indicatorData.length]=_1f;
_1f.draw(this._indicatorsGroup);
return _1f;
},removeIndicator:function(_20){
for(var i=0;i<this._indicatorData.length;i++){
if(this._indicatorData[i]===_20){
this._indicatorData.splice(i,1);
_20.remove();
break;
}
}
},moveIndicatorToFront:function(_21){
if(_21.shape){
_21.shape.moveToFront();
}
},drawText:function(_22,txt,x,y,_23,_24,_25){
var t=_22.createText({x:x,y:y,text:txt,align:_23});
t.setFill(_24?_24:"black");
if(_25){
t.setFont(_25);
}
return t;
},removeText:function(t){
if(t.parent){
t.parent.remove(t);
}
},updateTooltip:function(txt,e){
if(!_7.Tooltip){
return;
}
if(this._lastHover!=txt){
if(txt!==""){
_7.hideTooltip(this.mouseNode);
_7.showTooltip(txt,this.mouseNode,!this.isLeftToRight());
}else{
_7.hideTooltip(this.mouseNode);
}
this._lastHover=txt;
}
},handleMouseOver:function(_26){
if(this.image&&this.image.overlay){
if(_26.target==this._img.getEventSource()){
var _27;
this._overOverlay=true;
var r=this.getRangeUnderMouse(_26);
if(r&&r.hover){
_27=r.hover;
}
if(_7.Tooltip&&this.useTooltip&&!this._drag){
if(_27){
this.updateTooltip(_27,_26);
}else{
this.updateTooltip("",_26);
}
}
}
}
},handleMouseOut:function(_28){
this._overOverlay=false;
if(_7.Tooltip&&this.useTooltip&&this.mouseNode){
_7.hideTooltip(this.mouseNode);
}
},handleMouseMove:function(_29){
if(_7.Tooltip){
if(_29){
_1.style(this.mouseNode,"left",_29.pageX+1+"px");
_1.style(this.mouseNode,"top",_29.pageY+1+"px");
}
if(this.useTooltip&&this._overOverlay){
var r=this.getRangeUnderMouse(_29);
if(r&&r.hover){
this.updateTooltip(r.hover,_29);
}else{
this.updateTooltip("",_29);
}
}
}
},handleMouseDown:function(_2a){
var _2b=this._getInteractiveIndicator();
if(_2b){
this._handleMouseDownIndicator(_2b,_2a);
}
},_handleDragInteractionMouseMove:function(_2c){
if(this._drag){
this._dragIndicator(this,_2c);
_1.stopEvent(_2c);
}
},_handleDragInteractionMouseUp:function(_2d){
this._drag=null;
for(var i=0;i<this._mouseListeners.length;i++){
_1.disconnect(this._mouseListeners[i]);
}
this._mouseListeners=[];
_1.stopEvent(_2d);
},_handleMouseDownIndicator:function(_2e,_2f){
if(!_2e.noChange){
if(!this._mouseListeners){
this._mouseListeners=[];
}
this._drag=_2e;
this._mouseListeners.push(_1.connect(document,"onmouseup",this,this._handleDragInteractionMouseUp));
this._mouseListeners.push(_1.connect(document,"onmousemove",this,this._handleDragInteractionMouseMove));
this._mouseListeners.push(_1.connect(document,"ondragstart",this,_1.stopEvent));
this._mouseListeners.push(_1.connect(document,"onselectstart",this,_1.stopEvent));
this._dragIndicator(this,_2f);
_1.stopEvent(_2f);
}
},_handleMouseOverIndicator:function(_30,_31){
if(_7.Tooltip&&this.useTooltip&&!this._drag){
if(_30.hover){
_1.style(this.mouseNode,"left",_31.pageX+1+"px");
_1.style(this.mouseNode,"top",_31.pageY+1+"px");
_7.showTooltip(_30.hover,this.mouseNode,!this.isLeftToRight());
}else{
this.updateTooltip("",_31);
}
}
if(_30.onDragMove&&!_30.noChange){
this.gaugeContent.style.cursor="pointer";
}
},_handleMouseOutIndicator:function(_32,_33){
if(_7.Tooltip&&this.useTooltip&&this.mouseNode){
_7.hideTooltip(this.mouseNode);
}
this.gaugeContent.style.cursor="pointer";
},_handleMouseOutRange:function(_34,_35){
if(_7.Tooltip&&this.useTooltip&&this.mouseNode){
_7.hideTooltip(this.mouseNode);
}
},_handleMouseOverRange:function(_36,_37){
if(_7.Tooltip&&this.useTooltip&&!this._drag){
if(_36.hover){
_1.style(this.mouseNode,"left",_37.pageX+1+"px");
_1.style(this.mouseNode,"top",_37.pageY+1+"px");
_7.showTooltip(_36.hover,this.mouseNode,!this.isLeftToRight());
}else{
this.updateTooltip("",_37);
}
}
},handleTouchStartIndicator:function(_38,_39){
if(!_38.noChange){
this._drag=_38;
_1.stopEvent(_39);
}
},handleTouchStart:function(_3a){
this._drag=this._getInteractiveIndicator();
this.handleTouchMove(_3a);
},handleTouchEnd:function(_3b){
if(this._drag){
this._drag=null;
_1.stopEvent(_3b);
}
},handleTouchMove:function(_3c){
if(this._drag&&this._drag.noChange==false){
var _3d=_3c.touches;
var _3e=_3d[0];
this._dragIndicatorAt(this,_3e.pageX,_3e.pageY);
_1.stopEvent(_3c);
}
},_getInteractiveIndicator:function(){
for(var i=0;i<this._indicatorData.length;i++){
var _3f=this._indicatorData[i];
if(_3f.interactionMode=="gauge"&&!_3f.noChange){
return _3f;
}
}
}});
});
